#ifndef VIEDITVIEW_H
#define VIEDITVIEW_H

#include <QPlainTextEdit>
#include "vi.h"

//class LineNumberArea;
class ViEngine;

class ViEditView : public QPlainTextEdit
{
	Q_OBJECT

#if 0	//	vi.h Ɉړ
public:
	enum Mode {
		CMD = 0,
		INSERT,
	};
#endif

public:
	ViEditView(QWidget *parent = 0);
	~ViEditView();

public:
	Mode	mode() const { return m_mode; }
	int		lineNumberAreaWidth() const;

public:
#if !USE_EVENT_FILTER
	void	setViEngine(ViEngine *viEngine) { m_viEngine = viEngine; }
#endif
	void	moveCursor(QTextCursor::MoveOperation, int n = 1);
	void	lineNumberAreaPaintEvent(QPaintEvent *event);

public slots:
	void	setMode(Mode mode);
	void	onCursorPositionChanged();

protected:
	bool	eventFilter(QObject *obj, QEvent *event);
	void	resizeEvent(QResizeEvent *event);
	void	paintEvent(QPaintEvent * event);
#if !USE_EVENT_FILTER
	void	keyPressEvent ( QKeyEvent * event );
#endif

	//void	onLineNumberAreaWidthChanged();
	void	drawLineNumbers();

signals:
	void	modeChanged(Mode);

private:
	Mode	m_mode;
#if !USE_EVENT_FILTER
	ViEngine	*m_viEngine;
#endif
	QWidget	*m_lineNumberArea;
	int		m_lineNumberAreaWidth;
	int		m_lineNumberWidth;
};

#if 0
class LineNumberArea : public QWidget
{
public:
	LineNumberArea(ViEditView *editor)
		: m_editor(editor), QWidget(editor) {}

public:
	QSize sizeHint() const
	{ return QSize(m_editor->lineNumberAreaWidth(), 0); }

protected:
	void paintEvent(QPaintEvent *event)
	{ m_editor->lineNumberAreaPaintEvent(event); }

private:
	ViEditView	*m_editor;
};
#endif
#endif // VIEDITVIEW_H
