#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "vi.h"

class ViEditView;
class ViEngine;
class QLineEdit;

class MainWindow : public QMainWindow
{
	Q_OBJECT

public:
	MainWindow(QWidget *parent = 0, Qt::WFlags flags = 0);
	~MainWindow();

public slots:
	void	onImeOpenStatusChanged();
	void	onModeChanged(Mode);
	void	cmdLineTextChanged(const QString & text);
	void	cmdLineReturnPressed();
	void	cmdLineCursorPositionChanged(int, int);

protected:
	bool	eventFilter(QObject *obj, QEvent *event);

private:
	ViEditView	*m_editor;
	ViEngine	*m_viEngine;
	QLineEdit	*m_cmdLineEdit;
};

#endif // MAINWINDOW_H
